<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<html><head><title>
Xv Manual: Units
</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta http-equiv="Content-Style-Type" content="text/css">
<link rel="stylesheet" title="Default" type="text/css" href="allegro.css"></head><body bgcolor=white text=black link="#0000ee" alink="#ff0000" vlink="#551a8b">
<h1><a name="Units">Units</a></h1>

<p>
Data in plots or images have one or several units which are define by a
structure specifying the type of unit and the affine transform which turn
the data numbers in physicals measure. A typical situation is for instance
to the data coming from an AD converter which are integer values ranging from
0 to 65535 for



<p><br>
<div class="al-api"><b>typedef struct unit_set <a name="un_s">un_s</a>;</b></div><br>
<blockquote class="code"><pre>
    int     type, sub_type, axis;      identifier 
    float   ax, dx;                    the offset and increment 
    char    decade;                    the decade value
    char    mode;                      log or a^2 
    char    *name;                     the text of it 
</pre></blockquote>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#build_unit_set" title="">build_unit_set</a>,
<a class="xref" href="#free_unit_set" title="">free_unit_set</a>,
<a class="xref" href="#duplicate_unit_set" title="">duplicate_unit_set</a>.</blockquote>
<div class="al-api"><b>#define    <a name="get_unit_type">get_unit_type</a>(un)        </b></div><br>
    Macro allowing to acces the unit set type;


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#set_unit_type" title="">set_unit_type</a>.</blockquote>
<div class="al-api"><b>#define    <a name="set_unit_type">set_unit_type</a>(un, type)    </b></div><br>
    Macro defining the unit set type which may be one of the value below;
        

<blockquote class="text"><pre>
         IS_VOLT            
         IS_AMPERE        
         IS_METER        
         IS_NEWTON        
         IS_SECOND        
         IS_GRAMME        
         IS_GAUSS        
         IS_OHM            
         IS_RAW_U                 
</pre></blockquote>



<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#get_unit_type" title="">get_unit_type</a>.</blockquote>
<div class="al-api"><b>#define    <a name="get_unit_sub_type">get_unit_sub_type</a>(un)        </b></div><br>
    Macro allowing to acces the unit set subtype;


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#set_unit_sub_type" title="">set_unit_sub_type</a>.</blockquote>
<div class="al-api"><b>#define    <a name="set_unit_sub_type">set_unit_sub_type</a>(un,stype)    </b></div><br>
    Macro defining the unit set subtype;



<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#get_unit_sub_type" title="">get_unit_sub_type</a>.</blockquote>
<div class="al-api"><b>#define    <a name="get_unit_axis">get_unit_axis</a>(un)        </b></div><br>
    Macro allowing to acces the unit set axis;


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#set_unit_axis" title="">set_unit_axis</a>.</blockquote>
<div class="al-api"><b>#define    <a name="set_unit_axis">set_unit_axis</a>(un,axis)        </b></div><br>
    Macro defining the unit set axis which may be one of the value below;

<blockquote class="text"><pre>
        IS_X_UNIT_SET        
        IS_Y_UNIT_SET        
        IS_Z_UNIT_SET        
        IS_T_UNIT_SET        
        IS_UNIT_SET        
</pre></blockquote>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#get_unit_axis" title="">get_unit_axis</a>.</blockquote>
<div class="al-api"><b>#define    <a name="set_unit_decade">set_unit_decade</a>(un,dec)    </b></div><br>
    Macro allowing to acces the unit set decade;
    

<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#get_unit_decade" title="">get_unit_decade</a>.</blockquote>
<div class="al-api"><b>#define    <a name="get_unit_decade">get_unit_decade</a>(un)    </b></div><br>
    Macro defining the unit set decade which may be one of the value below;

<blockquote class="text"><pre>
         IS_TERRA          12
         IS_GIGA            9
         IS_MEGA            6
         IS_KILO            3
         IS_MILLI          -3
         IS_MICRO          -6
         IS_NANO           -9
         IS_PICO          -12
         IS_FEMTO         -15
</pre></blockquote>



<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#set_unit_decade" title="">set_unit_decade</a>.</blockquote>
<div class="al-api"><b>#define    <a name="set_unit_offset">set_unit_offset</a>(un,off)    </b></div><br>
    Macro defining the unit set offset of the affine transformation.
    

<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#get_unit_offset" title="">get_unit_offset</a>,
<a class="xref" href="#get_unit_increment" title="">get_unit_increment</a>,
<a class="xref" href="#set_unit_increment" title="">set_unit_increment</a>.</blockquote>
<div class="al-api"><b>#define    <a name="get_unit_offset">get_unit_offset</a>(un)        </b></div><br>
    Macro allowing to acces the unit set offset of the affine transformation.


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#set_unit_offset" title="">set_unit_offset</a>,
<a class="xref" href="#get_unit_increment" title="">get_unit_increment</a>,
<a class="xref" href="#set_unit_increment" title="">set_unit_increment</a>.</blockquote>
<div class="al-api"><b>#define    <a name="set_unit_increment">set_unit_increment</a>(un,inc)    </b></div><br>
    Macro allowing to acces the unit set increment of the affine transformation.


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#get_unit_increment" title="">get_unit_increment</a>,
<a class="xref" href="#set_unit_offset" title="">set_unit_offset</a>,
<a class="xref" href="#get_unit_offset" title="">get_unit_offset</a>.</blockquote>
<div class="al-api"><b>#define    <a name="get_unit_increment">get_unit_increment</a>(un)        </b></div><br>
    Macro defining the unit set increment of the affine transformation.


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#set_unit_increment" title="">set_unit_increment</a>,
<a class="xref" href="#set_unit_offset" title="">set_unit_offset</a>,
<a class="xref" href="#get_unit_offset" title="">get_unit_offset</a>.</blockquote>
<div class="al-api"><b>#define    <a name="set_unit_mode">set_unit_mode</a>(un,mod)    </b></div><br>
    Macro defining the unit set mode.


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#get_unit_mode" title="">get_unit_mode</a>.</blockquote>
<div class="al-api"><b>#define    <a name="get_unit_mode">get_unit_mode</a>(un)    </b></div><br>
    Macro allowing to acces the unit set mode.


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#set_unit_mode" title="">set_unit_mode</a>.</blockquote>
<div class="al-api"><b>#define    <a name="set_unit_name">set_unit_name</a>(un,name)    </b></div><br>
    Macro defining the unit set name, name is a string that is attached to the 
 structure.


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#get_unit_name" title="">get_unit_name</a>.</blockquote>
<div class="al-api"><b>#define    <a name="get_unit_name">get_unit_name</a>(un)    </b></div><br>
    Macro allowing to acces the unit set name.



<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#set_unit_name" title="">set_unit_name</a>.</blockquote>
<div class="al-api"><b>un_s* <a name="build_unit_set">build_unit_set</a> (int t, float ax, float dx, char d, char m, char *name);</b></div><br>
    Create the unitset structure in one step, the name is duplicated.
<blockquote class="code"><pre>
    un = <a href="#build_unit_set" class="autotype" title="">build_unit_set</a>(IS_VOLT, -5, (float)10/16384, 0, 0, "V");
</pre></blockquote>
    This create a unit set which will convert from a 16 bits CAD to volts. 


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#free_unit_set" title="">free_unit_set</a>,
<a class="xref" href="#duplicate_unit_set" title="">duplicate_unit_set</a>.</blockquote>
<div class="al-api"><b>int <a name="free_unit_set">free_unit_set</a>(un_s *uns);</b></div><br>
    Free the unit set.


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#build_unit_set" title="">build_unit_set</a>,
<a class="xref" href="#duplicate_unit_set" title="">duplicate_unit_set</a>.</blockquote>
<div class="al-api"><b>un_s* <a name="duplicate_unit_set">duplicate_unit_set</a>(un_s *dest, un_s *src);</b></div><br>
    Copy one unit set in dest if dest is different from NULL, otherwise
 create a copy of src.

    



<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#build_unit_set" title="">build_unit_set</a>,
<a class="xref" href="#free_unit_set" title="">free_unit_set</a>.</blockquote>
<div class="al-api"><b>char* <a name="generate_units">generate_units</a> (int type, int decade);</b></div><br>
    Construct a string describing the actual unit.
<blockquote class="code"><pre>
    char *name;
    name = <a href="#generate_units" class="autotype" title="">generate_units</a> (IS_VOLTS, IS_MICRO);
</pre></blockquote>    
    Will produce a string containing "\\mu V" (micro Volts).
    


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#unit_to_type" title="">unit_to_type</a>.</blockquote>
<div class="al-api"><b>int <a name="unit_to_type">unit_to_type</a> (char *unit, int *type, int *decade);</b></div><br>
    Just do the opposite: 
<blockquote class="code"><pre>
    int type, decade;
    <a href="#unit_to_type" class="autotype" title="">unit_to_type</a> ("\\mu V",&amp;type, &amp;decade);
</pre></blockquote>    
    Will produce place IS_VOLTS in type and IS_MICRO in decade.


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#generate_units" title="">generate_units</a>.</blockquote>
<div class="al-api"><b>int <a name="change_decade">change_decade</a> (un_s *un, int dec);</b></div><br>
    Allow to switch from micro to nano for instance. The affine transformation
 increment and the unit name is change accordingly.
    

<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#compare_units" title="">compare_units</a>.</blockquote>
<div class="al-api"><b>int <a name="compare_units">compare_units</a> (un_s *a, un_s *b);</b></div><br>
    Compare two unit sets and return 0 if they correspond to the same unit, 
 otherwise return 1. This fuction handle correctly the fact that the unit 
 sets are in different decade mode (you can compare microvolts and kilovolts) 


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#change_decade" title="">change_decade</a>.</blockquote>
<div class="al-api"><b>int <a name="modify_un_decade">modify_un_decade</a> (void);</b></div><br>
    Menu function allowing to modify the decade.


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#modify_units" title="">modify_units</a>,
<a class="xref" href="#modify_units_prime" title="">modify_units_prime</a>.</blockquote>
<div class="al-api"><b>int <a name="modify_units">modify_units</a> (void);</b></div><br>
    Menu function allowing to modify the normal unit set of an image or a plot.


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#modify_un_decade" title="">modify_un_decade</a>,
<a class="xref" href="#modify_units_prime" title="">modify_units_prime</a>.</blockquote>
<div class="al-api"><b>int <a name="modify_units_prime">modify_units_prime</a> (void);</b></div><br>
    Menu function allowing to modify the unit set of a plot associated with the top and right axis.


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#modify_un_decade" title="">modify_un_decade</a>,
<a class="xref" href="#modify_units" title="">modify_units</a>.</blockquote>
<div class="al-api"><b>int <a name="add_new_units">add_new_units</a> (void);</b></div><br>
    Menu function allowing to add a new unit set.
    

<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#switch_un_ty" title="">switch_un_ty</a>.</blockquote>
<div class="al-api"><b>int <a name="switch_un_ty">switch_un_ty</a> (void);</b></div><br>
    Menu function allowing to switch type.


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#switch_un_dec" title="">switch_un_dec</a>,
<a class="xref" href="#add_new_units" title="">add_new_units</a>.</blockquote>
<div class="al-api"><b>int <a name="switch_un_dec">switch_un_dec</a> (void);</b></div><br>
    Menu function allowing to switch decade.


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#switch_un_ty" title="">switch_un_ty</a>,
<a class="xref" href="#add_new_units" title="">add_new_units</a>.</blockquote>
<div class="al-api"><b>int    <a name="get_afine_param_from_unit">get_afine_param_from_unit</a> (un_s *un, float *ax, float *dx);</b></div><br>
    This function return the affine transform parameters corresponding to a 
 unit set in  the decade = 0 mode so that you can easily compare units.


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#set_afine_param_for_unit_with_decade" title="">set_afine_param_for_unit_with_decade</a>.</blockquote>
<div class="al-api"><b>int    <a name="set_afine_param_for_unit_with_decade">set_afine_param_for_unit_with_decade</a> (un_s *un, float ax, float dx, int decade);</b></div><br>
    This function is used to set the affine transform parameters of a unit set 
 with the specify decade. ax and dx are give in zero decade mode the unitset is
 transform to the specify deacde.
<blockquote class="code"><pre>
    <a href="#set_afine_param_for_unit_with_decade" class="autotype" title="">set_afine_param_for_unit_with_decade</a> (un, -5, (float)10/16384, IS_MILLI);
</pre></blockquote>    
    set the unit set for the AD converter in the -5000 mV to + 5000 mV range.  



<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#un_s" title="">un_s</a>,
<a class="xref" href="#get_afine_param_from_unit" title="">get_afine_param_from_unit</a>.</blockquote>
<hr><div class="al-back-to-contents"><a href="xvin.html">Back to contents</a></div>

</body>
</html>
